		RADIX dec
;
		list	p=12F629           ; list directive to define processor
        #include	<p12F629.inc>
        errorlevel -302			; suppress "register not in bank0, check page bits" message.	
;

		EXTERN	addID,getID,pulseLock,OpenLock,HSdelay,purgeDB,numID,matchID

#define	Purge	GPIO,GP0

vars	UDATA_SHR	0x20
IDs		RES	1					; # IDs in DB

master	CODE	0
start
        clrf   	GPIO
        movlw   B'00000111'
        movwf   CMCON			; Select GPIO
		bsf STATUS,RP0 			; Bank 1
		call 3FFh 				; Get the cal value
		movwf OSCCAL 			; Calibrate
        movlw   B'00001111'		; Enable pull-ups
        movwf   OPTION_REG
        movlw   B'00001001'     ; GP1,GP2 = output, GP0,GP3 = input
        movwf	TRISIO
		bcf STATUS,RP0 			; Bank 0

		call numID				; Get # IDs in W
		movwf IDs
		btfsc STATUS,Z			; Z means none, get master
		goto GetMaster
main	call getID				; Wait for an ID
		call matchID			; Search in database
		btfsc STATUS,Z			; Match ?
		goto main				; No, loop
		subwf IDs,w				; Check if Master
		btfsc STATUS,Z			; Master ?
		goto Special			; Yes, enter auth mode / purge
open	call OpenLock			; No, just open
		goto main

Special	call pulseLock			; Acknowledge (2 short pulses)
		call HSdelay
		call pulseLock
		btfsc Purge				; purge ?
		goto DOPurge
		call getID				; no, Wait for an ID
		call matchID			; Search in database
		btfsc STATUS,Z			; Match ?
		goto learn				; No, learn
		subwf IDs,w				; Check if Master
		btfss STATUS,Z			; Master ?
		goto Special			; No, ignore
		goto open				; Yes, exit auth mode (ack by open)
learn	call addID				; add to DB
		call OpenLock			; acknowledge by opening (ignore errors)
		goto start

DOPurge	call purgeDB			; Purge database
		call HSdelay			; Acknowledge (3 short pulses)
		call pulseLock
		goto start				; restart

GetMaster
		call pulseLock			; Acknowledge (1 short pulse)
		call HSdelay
		call getID				; Wait for an ID
		call addID				; Store
		call pulseLock			; Acknowledge (1 short pulse)
		call HSdelay
		goto start				; restart

		end
